"use strict";var trace,element_assist={CheckElement:CheckElement},NetcoValidation=require("../../app-lib/validationstr/netcovalidation.js"),TypeConversion=require("../../app-lib/conversions/typeconversion.js"),typeconversion=new TypeConversion,vld=new NetcoValidation(typeconversion);function CheckElement(e,n,r,t){var o={status:"ok",data:n},i={...t,...n},a=[];return[CheckFrequencyRange,CheckFreqVsChannelSpacing,ChannelListIdDuplication,DefaultChannel,PortFunctionConflict,RegionCodeVsFactoryRegionCode,USARestrictions,RURestrictions,CallBookConflicts,FreewaveModeVsEnabledRadioStates,HopTableSizeAndRegionCode,HopTableVersionAndRegionCode,TXPowerRestrictions].forEach(n=>{var t=n(e,i,r);null!=t&&a.push(t)}),a.length>0&&(o.status="error",o.error=1==a.length?a[0]:"Found "+a.length+" issues. First issue:\n"+a[0]),o}function CheckerTemplate(e,n,r){return"Error"}function CheckFrequencyRange(e,n,r){var t=null;if("file"==e.data_src||"db"==e.data_src)return null;var o=function(e,r,t){return e in n&&r in n&&t in n&&(trace.Info("CheckFrequencyRange.isFreqInvalid: max="+n[t]+"  min="+n[r]+" "+e+"="+n[e]),"0"!=n[t]&&"0"!=n[r]&&(parseInt(n[e])>parseInt(n[t])||parseInt(n[e])<parseInt(n[r])))},i=[];return o("radio.tx_freq","radio.min_tx_freq","radio.max_tx_freq")&&i.push("TX Frequency"),o("radio.rx_freq","radio.min_rx_freq","radio.max_rx_freq")&&i.push("RX Frequency"),i.length>0&&(t=1==i.length?i[0]+" is out of range":i.join(", ")+"\nare out of range"),t}function CheckFreqVsChannelSpacing(e,n,r){var t=null;if("radio.sel_chn_width"in n||"radio.chn_spacing"in n){var o=[],i="64"==n["radio.sel_chn_width"]||"20000"==n["radio.chn_spacing"]?1e4:6250;n["radio.tx_freq"]&&parseInt(n["radio.tx_freq"])%i!=0&&o.push("TX Frequency"),n["radio.rx_freq"]&&parseInt(n["radio.rx_freq"])%i!=0&&o.push("RX Frequency"),n["radio.center_freq"]&&parseInt(n["radio.center_freq"])%i!=0&&o.push("Reference Frequency"),o.length>0&&(t=1==o.length?o[0]+" doesn't match channel spacing":o.join(", ")+"\ndon't match channel spacing")}return t}function ChannelListIdDuplication(e,n,r){var t=null;const o="channel_list_folder.ch_list_array";if(o in n&&n[o].length>0){var i=[];n[o].forEach(e=>{var n="",a=vld.GetLowValueFromIX(e,vld.VldStrToObj(r[o].vld_str),function(e){return e.indexOf("_id")>=0&&(n=e),r[o].struct_data[e].vld_str});-1==i.indexOf(a[n])?i.push(a[n]):t="Duplicated channel number in the Channel List"})}return t}function DefaultChannel(e,n,r){var t=null;const o="channel_list_folder.manual_scan_default_chn",i="channel_list_folder.ch_list_array";if(o in n&&n[i].length>0){var a="";null==n[i].find(e=>{return vld.GetLowValueFromIX(e,vld.VldStrToObj(r[i].vld_str),function(e){return e.indexOf("_id")>=0&&(a=e),r[i].struct_data[e].vld_str})[a]==n[o]})&&(t="Invalid default channel "+n[o]+".\n The channel is not found in the Channel List.")}return t}function PortFunctionConflict(e,n,r){var t=null;const o="serial_ports.port1_settings.port1_function_basic",i="serial_ports.port2_settings.port2_function_basic";return o in n&&i in n&&n[o]==n[i]&&(t="Port 1 and Port 2 functions can't be set to "+("0"==n[o]?"OFF":"ON")+" at the same time."),t}function RegionCodeVsFactoryRegionCode(e,n,r){var t=null;const o="general.region_code",i="general.factory_region_code";o in n&&i in n&&"255"!=n[i]&&"0"!=n[i]&&(("1"==n[i]&&"1"!=n[o]||"2"==n[i]&&"7"!=n[o]||"3"==n[i]&&"3"!=n[o]||"5"==n[i]&&"5"!=n[o]||"4"==n[i]&&"8"!=n[o]||"6"==n[i]&&"9"!=n[o])&&(t="Invalid region code selected! Allowed region code: "+vld.GetChoiceNameByValue(n[i],vld.VldStrToObj(r[i].vld_str))));return t}function USARestrictions(e,n,r){var t=null;const o="channel_list_folder.ch_list_array",i="Settings conflict FCC regulations!\nTransmitting on a 25 kHz channel is prohibited in the USA if the radio link rate is below 19200 bps.",a="if using any of the following radio protocols: PacCrest-GMSK, PacCrest 4800bps, Trimtalk 450s, Trimtalk 4800bps, or SATELLINE-2ASxE.";if("1"==n["general.region_code"]&&null!=n["radio.radio_compat"]&&["2","3","4","6","16","17","18","19","24","27","29","31"].includes(n["radio.radio_compat"]))if("4"==n["radio.sel_chn_width"]||"25000"==n["radio.chn_spacing"])t=i+" Check that the channel spacing is not set to 25 kHz "+a;else if(n[o]&&n[o].length>0){var l="";null!=n[o].find(e=>{return"25000"==vld.GetLowValueFromIX(e,vld.VldStrToObj(r[o].vld_str),function(e){return e.indexOf("_width")>=0&&(l=e),r[o].struct_data[e].vld_str})[l]})&&(t=i+" Check that the channel list does not contain 25 kHz channels "+a)}return t}function RURestrictions(e,n,r){var t=null;return"2"==n["general.region_code"]&&"1"==n["radio.radio_encryption.ota_encr"]&&(t="Settings conflict! Region code RU requires OTA Encryption to be OFF."),t}function CallBookConflicts(e,n,r){var t=null;const o="freewave.fwv_call_book.fwv_call_book_array";n[o]&&n[o].length>0&&(null!=n[o].find(e=>{return"0"!=vld.GetLowValueFromIX(e,vld.VldStrToObj(r[o].vld_str),function(e){return r[o].struct_data[e].vld_str}).call_book_addr})&&"255"!=n["freewave.fwv_multi_point_params.fwv_net_id"]&&0==["0","1","4","5","6"].includes(n["freewave.fwv_modem_mode"])&&(t="Settings conflict! A valid Call Book must be configured in Point-To-Point modes or when Network ID is 255"));return t}function FreewaveModeVsEnabledRadioStates(e,n,r){var t=null;const o="freewave.fwv_modem_mode";return"1"==n["radio.enabled_radio_states"]&&null!=n[o]&&"3"!=n[o]&&(t="Modem Mode conflicts Enabled radio states! Point to Multipoint Slave is the only applicable value for Rx Only modems."),t}function HopTableSizeAndRegionCode(e,n,r){var t=null;const o="freewave.fwv_transm_characteristics.fwv_hop_table_size";if("general.region_code"in n&&o in n)switch(n["general.region_code"]){case"1":case"9":"112"!=n[o]&&(t="Invalid Hop Table Size. The only applicable value for Region code "+{1:"USA",9:"Canada"}[n["general.region_code"]]+" is 112")}return t}function HopTableVersionAndRegionCode(e,n,r){var t=null;const o="general.region_code",i="freewave.fwv_transm_characteristics.fwv_hop_table_ver";if(o in n&&i in n){var a={1:"USA",9:"Canada",6:"New Zealand",7:"Australia",8:"Brazil"};switch(n[o]){case"1":case"9":0==["0","1","2","6"].includes(n[i])&&(t="Invalid Hop Table Version for Region code "+a[n[o]]);break;case"6":case"7":case"8":"1"!=n[i]&&(t="Invalid Hop Table Version for Region code "+a[n[o]])}}return t}function TXPowerRestrictions(e,n,r){var t=null;const o="channel_list_folder.ch_list_array";if("5"==n["general.region_code"]||"7"==n["general.region_code"])if(null!=n["radio.rf_output_pwr"]&&parseInt(n["radio.rf_output_pwr"])>25e3)t="Transmitter power level exceeds 25W. It is forbidden in your region.";else if(n[o]&&n[o].length>0){var i="";null!=n[o].find(e=>{var n=vld.GetLowValueFromIX(e,vld.VldStrToObj(r[o].vld_str),function(e){return e.indexOf("tx_power")>=0&&(i=e),r[o].struct_data[e].vld_str});return parseInt(n[i])>25e3})&&(t="Transmitter power level in the Channel list exceeds 25W. It is forbidden in your region.")}return t}module.exports=function(e){return trace=e,element_assist};