"use strict";var db,ngc,checkers,trace,bridge_gen,_=require("underscore"),nml_netgen_proxyarp={GetGens:GetGens,GenerateProxyArp:GenerateProxyArp,ResetProxyArp:ResetProxyArp};module.exports=function(e,t){return db=require("../../app-lib/ds_client_api/db_data_model.js")(e,t),ngc=require("../nml_netgen_common.js")(e,t),checkers=require("../nml_checkers.js")(e,t),bridge_gen=require("./bridge.js")(e,t),trace=t,nml_netgen_proxyarp};var util=require("util"),async=require("async");function GetGens(){return[{name:"Proxy Arp",id:"proxyarp",func:GenerateProxyArp,reset_func:ResetProxyArp,settings:{enabled:1,template:"192.168.0.0/24",selector:"*",mode:"all",offset:1,iphost_offset:20,wan_tgt:"123.123.1.0/24 192.168.1.100",wan_tgt_enabled:0,proxy_arp:!0,vlan_template_array:[],_do_map:[{name:"enabled",do_name:"netgen_lans_generation_mode",value:1,mapper:function(e){return"proxyarp"==e?1:0}},{name:"template",do_name:"netgen_lans_addr_template",value:"*"},{name:"selector",do_name:"netgen_lans_routing_selector",value:"*"},{name:"mode",do_name:"netgen_rlan_mode",value:"tree"},{name:"offset",do_name:"netgen_lans_cu_addr_offset",value:1},{name:"iphost_offset",do_name:"netgen_lans_iphost_addr_offset",value:1},{name:"wan_tgt",do_name:"netgen_wan_tgt",value:"123.123.1.0/24 192.168.1.100"},{name:"wan_tgt_enabled",do_name:"netgen_wan_tgt_enabled",value:0},{name:"vlan_template_array",do_name:"netgen_lans_vlan_addr_template",value:[]},{name:"netgen_lans_generation_mode",do_name:"netgen_lans_generation_mode"}]},managed_dobs:{ipt:[{do_id:"ipv4_addr"},{do_id:"ipv4_routes"}],router:[{do_id:"ipv4_interfaces"},{do_id:"ipv4_networks"}],cu:[{do_id:"ipv4_addr"},{do_id:"proxy_arp"},{do_id:"ipv4_routes"},{do_id:"bridge_mode"},{do_id:"bridge_allow_ip_addr"},{do_id:"vlan_array"}]},reset_dobs:{cu:[{do_id:"vlan_array"},{do_id:"proxy_arp"}]}}]}function ResetProxyArp(e,t,n,a){return 1==ngc.IsNetgenStopped(e)?a("STOP: data not relevant any more",[]):(_.each(n.cu_ids,function(e){var t=n.all_devs[e];ngc.markDobForUpdate(t.dobs.proxy_arp,0),trace.Info("Node "+t.n_id+"  vlan_array before clean="+JSON.stringify(t.dobs.vlan_array.uxFmt)),ngc.markDobForUpdate(t.dobs.vlan_array,[]),trace.Info("cu.dobs.vlan_array after clean ="+JSON.stringify(t.dobs.vlan_array.uxFmt))}),_.each(n.ipt_ids,function(e){var t=n.all_devs[e];ngc.markDobForUpdate(t.dobs.ipv4_addr,[])}),a(null,[]))}function GenerateProxyArp(e,t,n,a){trace.Info("GenerateProxyArp starting");var r=[];if(1==ngc.IsNetgenStopped(e))return a("STOP: data not relevant any more",[]);if(0==ngc.IsIPv4Cidr(t.template))return a("Invalid LAN Template Address");var o=t.template.split("/"),i=o[0].split(".");i[0],i[1],i[2],i[3],o[1],t.template;async.series({check_cu_count:function(e){if(trace.Info("============= check_cu_count ============="),n.stations.length<2){var t="At least two CUs required for Proxy ARP";return r.push({type:"warning",msg:t}),e(t)}return e()},check_vrrp:function(e){trace.Info("============= check_for_vrrp =============");var t=[];if(_.each(n.stations,function(e){e.isVRRP()&&t.push(e)}),t.length>0){var a="No support for VRRP nodes in Proxy ARP mode. The following nodes are currently using VRRP: "+_.map(t,function(e){return e.getInfo()}).join();return r.push({type:"warning",msg:a}),e()}return e()},check_root_count:function(e){trace.Info("============= check_root_count =============");var t,a=0;if(_.each(n.stations,function(e){e.isRoot()&&(a++,t=e)}),!t){var o="ROOT CU required for Proxy ARP";return r.push({type:"warning",msg:o}),e(o)}if(a>1){o="More than one Root Node detected!";return r.push({type:"error",msg:o}),e(o)}return e()},check_ips:function(e){trace.Info("============= check_ips ============="),checkers.checkAndAssignIPAddrs(n,t,function(t,n,a,o){trace.Info("checkAndAssignIPAddrs results: "+util.inspect(n)),r=r.concat(n),e(t)})},generate_vlans:function(a){trace.Info("============= generate_vlans ============="),bridge_gen.generateVLANs(e,n,t,function(e,t){r=r.concat(t),trace.Info("generateVLANs results: "+util.inspect(t)),a(e)})},create_lan32_routes:function(e){trace.Info("============= create_lan32_routes ============="),createLAN32Routes(n,t,function(t,n){trace.Info("createLAN32Routes results: "+util.inspect(n)),r=r.concat(n),e(t)})},create_ip_dev_routes:function(e){trace.Info("============= create_ip_dev_routes ============="),bridge_gen.createIPDeviceRoutes(n,function(t,n){trace.Info("createIPDeviceRoute results: "+util.inspect(n)),r=r.concat(n),e(t)})},set_proxy_arp:function(e){trace.Info("============= set_proxy_arp ============="),_.each(n.cu_ids,function(e){var t=n.all_devs[e];ngc.markDobForUpdate(t.dobs.proxy_arp,1)}),e()},add_wan_targets:function(e){trace.Info("============= add_wan_targets ============="),_.each(n.cu_ids,function(e){var a=n.all_devs[e],o=a.dobs.ipv4_routes.getVals()||[],i=bridge_gen.addWanRoute(t,a.n_id,o);trace.Info("addWanRoute results: "+util.inspect(i)),i&&(r=r.concat(i)),ngc.markDobForUpdate(a.dobs.ipv4_routes,o)}),e()}},function(e,t){trace.Info("============= Proxy ARP Gen finished ============="),ngc.elapsed("Proxy ARP Gen finished"),a(e,r)})}function createLAN32Routes(e,t,n){var a=[],r=e.ipt_ids;r=r.concat(e.router_ids),trace.Info("IP TARGETS: "+r);var o=[];_.each(r,function(t){var n=e.nodes[t],r=e.getConnectedStation(n.n_id);r?(trace.Info("FOUND Station for IP DEVICE node: "+n.n_id+" Station: "+r.getInfo()),o.push({target:n,station:r})):(trace.Error("IP Host or Router node: "+n.n_id+" must be connected to a Radio node"),a.push({type:"error",msg:"IP Host or Router node: "+n.n_id+" must be connected to a Radio node"}))}),_.each(e.stations,function(e){_.each(e.nodes,function(t){o.push({station:e,target:t})})});var i={};function c(e,t){trace.Debug("Adding Routes for station "+util.inspect(t));var n=_.map(e[t.getId()].target_ips,function(n){var a=e[t.getId()].station_tun0_ips;return _.map(a,function(e){return n+" "+e.split("/")[0]})});return trace.Info("Routes for station "+t.getInfo()+": "+n),_.flatten(n)}_.each(o,function(e){var t=e.station,n=e.target.getRouteTargetIPAddrs(),a=[];_.each(n,function(e){var t=e.split("/")[0]+"/32";a.push(t)});var r=t.getVDobsByName("ipv4_addr","eth"),o=_.compact(_.flatten(_.map(r,function(e){return e.getValues()})));trace.Info("ProxyARP gen found tun0 IPs: "+o),i[t.getId()]?i[t.getId()].target_ips=i[t.getId()].target_ips.concat(a):i[t.getId()]={target_ips:a,station_tun0_ips:o}}),trace.Info(util.inspect(i));var s=e.getRootStation();if("all"==t.mode)_.each(e.stations,function(t){var n=[];_.each(_.without(e.stations,t),function(e){n=n.concat(c(i,e))});var a=t.getVDobsByName("ipv4_routes");_.each(a,function(e){e.markForUpdate(n)})});else{var d={};_.each(e.stations,function(e){d[e.getId()]=[]});var u=e.getLeafRadioStations();u=_.chain(u).map(function(t){for(;!t.isIPRadio();){trace.Info("Leaf "+t.getInfo()+" has no CU");var n=e.getVPathAsStations(t.mainnode.id,s.mainnode.id);if(trace.Info("vpathToRoot = "+util.inspect(n)),!(n.length>1))return t=s,trace.Info("Root reached, returning null"),null;t=n[1],trace.Info("Next leaf toward root is "+t.getInfo())}return trace.Info("Returning leaf Station: "+t.getInfo()),t}).unique().compact().value(),trace.Debug("LEAVES: "+util.inspect(u)),_.each(u,function(n){var a=_.chain(e.getVPathAsStations(n.mainnode.id,s.mainnode.id)).map(function(e){return e.isIPRadio()?e:null}).compact().value();_.each(a,function(e){var n=[];if("tree"==t.mode)for(var r=!1,o=0;o<a.length&&!r;++o)a[o]===e?(r=!0,e!=s&&n.push(s)):n.push(a[o]);else n=_.without(a,[e]);_.each(n,function(t){var n=c(i,t);_.each(n,function(t){d[e.getId()].push(t)})})})}),_.each(e.stations,function(e){var t=_.uniq(d[e.getId()]);trace.Info("IPROUTES ARRAY for Station node: "+e.getInfo()+" "+t);var n=e.getVDobsByName("ipv4_routes");_.each(n,function(e){e.markForUpdate(t)})})}n("",a)}