"use strict";var ich,db,ngc,ndm,not_log,defaults,trace,_=require("underscore"),util=require("util"),async=require("async"),ip=require("ip"),nml_checkers={PreGenerationCheck:PreGenerationCheck,PostGenerationCheck:PostGenerationCheck,getPostGenCheckDobs:getPostGenCheckDobs,AnytimeCheck:AnytimeCheck,checkAndAssignIPAddrs:checkAndAssignIPAddrs,getNextIP:getNextIP,checkLockedVLANFields:checkLockedVLANFields};function PreGenerationCheck(e,n,t,i){trace.Info("Pre-Generation Check started for netid: "+e);var r=[],c=null,o=isFragmented(t);if(o.err&&(c="fragmented",r.push({type:"error",msg:o.err})),trace.Info("Pre-Generation Check results: "+JSON.stringify(r)),c)return i(c,r);if(_.each(t.stations,function(e){e.isVRRP()&&e.subnodes.length<2&&(c="VRRP",r.push({type:"error",msg:"At least two sub-nodes should be connected to VRRP station "+e.getId()+" with VRRP link."}))}),c)return i(c,r);var a=0;for(const e in t.nodes)1==t.isRootNode(e)&&a++;if(a>1)return i("More than one Root Node in the network!",r);checkLockedVLANFields(e,n,t,function(e,n){i(e,n)})}function PostGenerationCheck(e,n,t,i){trace.Info("Post-Generation Check started for netid: "+e);async.auto({checkUniq:function(n){checkUniq(e,t,function(e,t){n(e,t)})},checkIPConflicts:function(e){checkIPConflicts(n,t,function(n,t){e(n,t)})}},function(e,n){trace.Info("Post-Generation Check results: "+JSON.stringify(n));var t=[];return _.each(n,function(e){t=t.concat(e)}),i(e,t)})}function getPostGenCheckDobs(){return{ru:[{do_id:"netid"},{do_id:"tx_freq"},{do_id:"rx_freq"}],cu:[{do_id:"ipv4_addr"},{do_id:"vlan_array"}],ipt:[{do_id:"ipv4_addr"}],router:[{do_id:"ipv4_interfaces"}]}}function AnytimeCheck(e,n){var t={id:"check"};if(!e.params)return n("no params in action request",t);if(!e.params.network_id)return n("no network_id in action request params",t);var i,r=e.params.network_id;trace.Info("AnytimeCheck started for netid: "+r);var c,o={},a={ru:[{do_id:"netid"},{do_id:"tx_freq"},{do_id:"rx_freq"}],cu:[{do_id:"ipv4_addr"},{do_id:"vlan_array"}],ipt:[{do_id:"ipv4_addr"}],router:[{do_id:"ipv4_interfaces"}]};async.auto({getName:function(e){ngc.getNetworkName(r,function(n){c=n,not_log.sendStartLogMsg(r,c,!1,"Check"),e()})},getSettings:function(e){ngc.getNetSettings(r,function(n,t){o=t,e(n)})},gatherData:["getName",function(e,n){ndm.gatherData(r,a,function(e,t){ngc.elapsed("gatherData finished, err: "+e),t&&(i=t),n(e)})}],checkNetwork:["gatherData",function(e,n){PreGenerationCheck(r,o,i,function(e,t){n(null,t)})}],checkUniq:["gatherData",function(e,n){checkUniq(r,i,function(e,t){n(e,t)})}],checkIPConflicts:["gatherData",function(e,n){checkIPConflicts(r,i,function(e,t){n(e,t)})}],checkLockedVLANFields:["gatherData",function(e,n){checkLockedVLANFields(r,o,i,function(e,t){n(e,t)})}],checkDefaults:["gatherData",function(e,n){defaults.CheckDefaults(r,i,function(e,t){n(e,t)})}]},function(e,i){trace.Info("Anytime Check results: "+JSON.stringify(i));var o=[];_.each(i,function(e){o=o.concat(e)});var a=[{effects:[]}];return _.each(o,function(e){e&&a[0].effects.push(e)}),not_log.sendValidationLog(r,a,c,!1,"Check"),n(e,t)})}function checkIPConflicts(e,n,t){var i=[],r=[],c={};return _.each(n.all_devs,function(e){var t=[].concat(n.getAllIPAddrs(e)).concat(n.getVLANAddrs(e));trace.Debug("DEV:: "+e.n_id+" ("+e._id+")  IPs="+JSON.stringify(t)),_.each(t,function(n){if(trace.Debug("IPA:: "+n),n){var t=function(e,n){var t={n_id:null,ipaddr:"",ifc:"",vlan:""};if(!n)return t;var i=n.split(" ");return t.ipaddr=i[0],i.length>1&&(t.ifc=i[1]),i.length>2&&(t.vlan=i[2]),t.n_id=e.n_id,t}(e,n);r.push(t),c[t.ipaddr]?c[t.ipaddr].push(t):c[t.ipaddr]=[t]}})}),trace.Info("checkIPConflicts. IP addresses:"+util.inspect(r)),_.each(c,function(e){e.length>1&&i.push({type:"warning",msg:"IP address conflict: "+e[0].ipaddr+" in nodes: "+_.map(e,function(e){return e.n_id}).join()})}),t(null,i)}function checkLockedVLANFields(e,n,t,i){var r=[],c=[],o=[],a=[],d=[];return _.each(t.all_devs,function(e){var i=t.getUserVLANAddrs(e);trace.Debug("DEV:: "+e.n_id+" ("+e._id+")  Locked VLANs="+JSON.stringify(i));var s=[];_.each(i,function(t){var i=t.split(" "),u=i[4],f=(i[5],i[6]);_.contains(s,i[3])?(trace.Error("Node "+e.n_id+": Duplicated vlan_id detected! "),r.push({type:"error",msg:"Locked VLAN addresses conflict in Node "+e.n_id+": vlan_id field must be unique"})):s.push(i[3]),"proxyarp"==n.netgen_lans_generation_mode&&(1==u||_.contains(c,e.n_id)||c.push(e.n_id),0==f||_.contains(a,e.n_id)||a.push(e.n_id)),-1==n.netgen_lans_generation_mode.indexOf("bridge")||1!=u&&1==f||_.contains(o,e.n_id)||(0==u||_.contains(o,e.n_id)||o.push(e.n_id),0==f||_.contains(d,e.n_id)||d.push(e.n_id))})}),c.length>0&&r.push({type:"warning",msg:"Locked VLAN error: in Proxy ARP mode 'proxy_arp'-field should be 1 in node(s): "+c.join()}),o.length>0&&r.push({type:"warning",msg:"Locked VLAN error: in Bridge mode 'bridged'-field should be 1 in node(s): "+o.join()}),a.length>0&&r.push({type:"warning",msg:"Locked VLAN error: in Proxy ARP mode 'bridged'-field should be 0 in node(s): "+a.join()}),d.length>0&&r.push({type:"warning",msg:"Locked VLAN error: in Bridge mode 'proxy_arp'-field should be 0 in node(s): "+d.join()}),i(r.length>0?"Locked VLAN conflicts":null,r)}function checkUniq(e,n,t){var i=[];trace.Info("CHECK UNIQ netid: "+e),function(e,n,t,i){db.GetDobsByUniq(e,n,t,function(e,n){if(e)return trace.Error("db.GetDobsByUniq() -> ERR: "+e),i(e);i(null,_.filter(n,function(e){return-1!=e.idx}))})}(e,_.map(n.all_devs,function(e){return e._id}),[0,1,2,3,7,8,9,10],function(e,r){if(e)return t(e);var c;c=r;var o={};_.each(c,function(e){var n=e.name+"_"+e.dmap_id;o[n]||(o[n]=[]);var t=0==e.chg_uid&&e.chg_str&&e.chg_str.length>0;e.ard>0&&0==e.awr?(0==t&&(e.val="Unknown (to be read from the device)",e.ux_val=e.val),o[n].push(e)):o[n].push(e)}),i=i.concat(function(e){var t=[];"chn_spacing_2400"in e&&e.chn_spacing_2400.length>0&&"sel_chn_width_2400"in e&&e.sel_chn_width_2400.length>0&&(e["3asnms_easy_mix"]=e.chn_spacing_2400.concat(e.sel_chn_width_2400),_.each(e["3asnms_easy_mix"],function(e){e.val=e.ux_val,e.ui_name="Selected Channel Width/Channel Spacing"}),delete e.chn_spacing_2400,delete e.sel_chn_width_2400);return _.each(e,function(e,i){var r=5,c={};switch(_.each(e,function(e){var n=JSON.stringify(e.val);c[n]||(c[n]=[]),c[n].push(e),r=e.uniq,trace.Debug("valkey"+n)}),r){case 0:case 1:case 2:case 3:t=t.concat(function(e,t){var i=[],r="must";2==t?r="should":3==t&&(r="is recommended to");var c,o=_.chain(e).map(function(e,t){var i=_.map(e,function(e){return n.all_devs[e.etr_id].n_id});return{count:e.length,ux_val:e[0].ux_val,val:t,name:e[0].ui_name,nodes:i.join(",")}}).sort(function(e){return e.count}).reverse().value(),a="";return _.each(o,function(e){c=e.name,e.count>1&&(a+=' the value "'+e.ux_val+'" appears in nodes: '+e.nodes)}),(a=a.split('""').join('"'))&&i.push({type:"warning",msg:"Warning: Value of "+c+" "+r+" be unique, but"+a}),trace.Info("checkUniqueness result: "+util.inspect(i)),i}(c,r));break;case 7:case 8:case 9:case 10:t=t.concat(function(e,t){var i=[],r="must";if(8==t?r="should":7==t&&(r="is recommended to"),1!=_.keys(e).length){var c,o=_.chain(e).map(function(e,t){var i=_.map(e,function(e){return n.all_devs[e.etr_id].n_id});return{count:e.length,val:t,ux_val:e[0].ux_val,name:e[0].ui_name,nodes:i.join(",")}}).sort(function(e){return e.count}).reverse().value(),a="",d=0;_.each(o,function(e,n){c=e.name;var t=' "'+e.ux_val+'" in node';t+=e.count>1?"s ":" ",t+=e.nodes,0==n?a=e.count<=3?t+" and ":'"'+e.ux_val+'" in most of the nodes and ':(d>0&&(a+=" and"),a+=t,d++)}),a=a.split('""').join('"'),i.push({type:"warning",msg:"Warning: Value of "+c+" "+r+" be same but is "+a+"."})}return trace.Info("checkSameness  result: "+util.inspect(i)),i}(c,r))}}),t}(o)),trace.Info("err: "+e+" RES: "+util.inspect(i)),t(e,i)})}function isFragmented(e){var n=_.values(e.nodes);if(0===n.length)return!1;for(var t,i=0,r=0;r<n.length&&0==i;++r)n[r].isLinkable()&&(i=1,t=n[r]);if(!t)return!1;trace.Debug("isFragmented starting node: "+util.inspect(t));var c=_.map(t.links,function(e){return _.extend(e,{node_id:t.id})});for(r=0;r<c.length;r++){var o=c[r];trace.Info("isFragmented linkid: "+o._id+" ifound "+i),e.links[o._id].if_visited=!0,i++;var a=e.nodes[e.getOtherEndID(o,o.node_id)];if(trace.Debug("Link "+util.inspect(o)),!a)return trace.Error("Link otherend is "+a),!0;_.each(a.links,function(n){e.links[n._id].if_visited||(trace.Info("Pushing link "+n._id+" node: "+a.id),c.push(_.extend(n,{node_id:a.id})))})}var d=0;return _.each(n,function(e){e.isLinkable()?(d++,trace.Info("Node "+e.n_id+" etr "+e.etr_id+" is linkable ")):trace.Info("Node "+e.n_id+" etr "+e.etr_id+" is not linkable ")}),i<d?(trace.Error("ifound = "+i+" nodecount = "+d),{err:"Network has Fragments!"}):i>d?(trace.Error("ifound = "+i+" nodecount = "+d),{err:"Network has Loops!"}):{err:""}}function checkAndAssignIPAddrs(e,n,t){var i,r,c="",o=[],a=n.template,d=[],s=null,u=null,f=null,l=0;if(0==ngc.IsIPv4Cidr(a))return t("Invalid LAN Template Address");if(n.iphost_offset&&(l=n.iphost_offset),_.each(e.cu_ids,function(n){var t=e.all_devs[n],i=[t].concat(ngc.getLinkedDevices(e,t,{link_ifcs:["eth"]}));_.each(i,function(n){_.each(e.getUserIPAddrs(n),function(e){e=e.split(" ")[0],d.push({id:n._id,ipa:e,n_id:n.n_id}),trace.Info("RESERVED, LOCKED: "+e)})})}),i=d.slice(),_.each(e.cu_ids,function(t){var i=e.all_devs[t],r=_.findIndex(i.dobs.ipv4_addr.uxFmt,function(e){return-1!=e.indexOf("eth0")});if(!i.dobs.ipv4_addr.isLocked(r)){var u=a.split(" ")[0],f=u.split("/")[0];if(!s){var l=ip.toLong(f)+~~n.offset;u=ip.fromLong(l)+"/"+u.split("/")[1],s=u}for(trace.Info("RESV_IPS: "+_.pluck(d,"ipa"));-1!=_.findIndex(d,function(e){return s==e.ipa});)s=getNextIP(s,ip.cidrSubnet(s));trace.Info("FINAL CU IP: "+s);var h=ip.cidrSubnet(s).networkAddress;ngc.isValidIPDeviceAddress(s,ip.cidrSubnet(s))||(o.push({type:"error",msg:"Not enough room in LAN "+h+" for Node: "+i.n_id+" address: "+s}),c="No room in LAN");e.setCUeth0Addr(i,s);d.push({id:t,ipa:s,n_id:i.n_id})}}),c)return t(c,o,d,r);if(_.each(e.cu_ids,function(n){var t=e.all_devs[n],i=ngc.getLinkedDevices(e,t,{link_ifcs:["eth"]}),r="";_.each(i,function(n){var t,i,c=a.split(" "),s=c[0];if(e.isIPT(n)&&!n.dobs.ipv4_addr.isLocked(0)){r=c[1]?c[1]:"eth0",u||(u=ngc.incIPAddr(s,l-1));do{u=getNextIP(u,ip.cidrSubnet(u))}while(-1!=_.findIndex(d,function(e){return u==e.ipa}));t=util.format("%s %s",u,r),trace.Info("newIpString: "+t),(i=e.setIPAddr(n,t))&&o.push({msg:i}),d.push({id:n._id,ipa:u,n_id:n.n_id})}else if(e.isRouter(n)&&!n.dobs.ipv4_interfaces.isLocked(0)){r=c[1]?c[1]:"eth0",f||(f=s);do{f=getNextIP(f,ip.cidrSubnet(f))}while(-1!=_.findIndex(d,function(e){return f==e.ipa}));t=util.format("%s %s",f,r),(i=e.setIPAddr(n,t))&&o.push({msg:i}),d.push({id:n._id,ipa:f,n_id:n.n_id})}})}),s)r=ip.cidrSubnet(s);else if(u)r=ip.cidrSubnet(u);else if(e.cu_ids.length>0){var h=e.getCUeth0Addr(e.all_devs[e.cu_ids[0]]);r=ip.cidrSubnet(h)}else r=ip.cidrSubnet(a.split(" "));var p=[];if(_.each(i,function(e){var n=e.ipa.split("/")[0],t=e.ipa.split("/")[1];r.subnetMaskLength!=t&&o.push({type:"warning",msg:"Locked IP "+e.ipa+" Mask does not match LAN "+r.networkAddress+"/"+r.subnetMaskLength});try{r.contains(n)||o.push({type:"warning",msg:"Locked IP "+e.ipa+" does not fit into LAN "+r.networkAddress+"/"+r.subnetMaskLength})}catch(e){p.push(e)}}),p.length>0)return t(p.join(", "),o);checkIPConflicts(n,e,function(e,n){if(n.length>0)return t("IP address conflict detected!",n);t(e,o,d,r)})}function getNextIP(e,n){trace.Info("getNextIP ( ip_addr = "+e+", common_subnet = "+n.networkAddress+"/"+n.subnetMaskLength+" )");var t=e.split("/");1==t.length&&t.push(n.subnetMaskLength);var i=t[0],r=t[1];if(ip.isV4Format(i)&&ip.cidr(i+"/"+r)==n.networkAddress){var c=ip.toLong(i);return ip.fromLong(c+1)+"/"+r}return(i=n.firstAddress)+"/"+r}module.exports=function(e,n){return ich=require("../app-lib/ichinterface/ichif.js")(e,n),db=require("../app-lib/ds_client_api/db_data_model.js")(e,n),ngc=require("./nml_netgen_common.js")(e,n),ndm=require("./nml_netgen_datamodel.js")(e,n),not_log=require("./notification_log.js")(e,n),defaults=require("./checkers/defaults.js")(e,n),trace=n,nml_checkers};