"use strict";var trace,crud,logdbo,flexsettings,db_cache,async=require("async"),timeStamp=require("../app-lib/utility/date_time"),mon_api_url="http://api:5000/api/v1",monitoring_data_cache={},mon_api={GetNetworkTopology:GetNetworkTopology,GetMonLatestValues:GetMonLatestValues,GetStatus:GetStatus,CleanCache:CleanCache};function CleanCache(e){monitoring_data_cache[e]=null}function GetStatus(e,n){if(""==flexsettings.GetSetting("postchg_hook",""))return n("No monitoring stack postchg_hook found");if(null==e)return n("No net_guid specified");var a=mon_api_url+"/status/"+e;trace.Info("Getting status url="+a),SendHTTPRequest(a,function(e,a){if(e)return trace.Error(e),n(e);n(null,a)})}function GetMonLatestValues(e,n){trace.Debug("Getting latest values for network "+e),SendHTTPRequest(mon_api_url+"/metrics/"+e+"/latest",function(a,t){if(a)return trace.Error(a),n(a);if(!Array.isArray(t))return n(`Invalid last_values received from monitoring API, last_values=${t}`);trace.Debug("Response from Mon API: "+JSON.stringify(t));var o={net_data:{},latest_values:[]},r=[];for(let e of t){if(!e||!Array.isArray(e.values)){const a=JSON.stringify(e||"Invalid last_values");return trace.Error(a),n(a)}e.values.forEach(function(e){var n=CamelToSnake(e.name);"time"!=n&&"source_name"!=n&&-1==r.indexOf(n)&&r.push(n)})}GetMonitoringData(e,r,function(a,r){if(trace.Debug("Response from GetMonitoringData: "+JSON.stringify(r)),a)return n(a);o.net_data=r.net_data,logdbo.ReadNetMonSyncLog(e,2,function(e,a){if(trace.Debug("Response from ReadNetMonSyncLog: "+JSON.stringify(a)),e)return n(e);try{var i=JSON.parse(a.data).alarms}catch(a){return trace.Error("Fail to parse alarm data "+a.message),n(e)}t.forEach(function(e){if(null!=r.nodes&&null!=r.nodes[e.nodeGuid]&&null!=e.nodeGuid){var n={n_id:r.nodes[e.nodeGuid].n_id,data:[]};e.values.forEach(function(a){var t=CamelToSnake(a.name);if("time"!=t&&"source_name"!=t){var o=i?i.find(n=>n.fieldName==t&&n.nodeGuid==e.nodeGuid):null,s=-1;o&&(s=a.value<o.warnHighThreshold&&a.value>o.warnLowThreshold?0:a.value<o.alarmLowThreshold||a.value>o.alarmHighThreshold?2:1);var d=e.values.find(e=>"time"==e.name&&e.rmac==a.rmac),l=d?timeStamp.GetTimeSpanInSec(new Date(d.value),new Date):0;(r.net_data.deadband&&"0"!=r.net_data.deadband&&l>parseInt(r.net_data.deadband)+60||l>3600)&&(s=3);var u={val:a.value,cond:s,time:d.value};for(var c in r.dobj_info[t])u[c]=r.dobj_info[t][c];if(null!=a.rmac){var _=a.rmac.split(".");null!=r.rmacs[_[0]]&&(u.n_id=r.rmacs[_[0]],n.data.push(u))}else n.data.push(u)}}),o.latest_values.push(n)}else trace.Debug("GetMonLatestValues: node not found!  node.nodeGuid="+e.nodeGuid+" mon_data.nodes="+JSON.stringify(r.nodes))}),trace.Debug("GetMonLatestValues result: "+JSON.stringify(o)),n(null,o)})})})}function SendHTTPRequest(e,n){require("http").get(e,e=>{let a="";e.on("data",e=>{a+=e}),e.on("end",()=>{a&&a.length>1?n(null,JSON.parse(a)):n("No data available in the response")})}).on("error",e=>{n(e.message)})}function SendHTTPPost(e,n,a){const t=require("http"),o=new URL(e),r={hostname:o.hostname,port:o.port,path:o.path,method:"POST",headers:{"Content-Type":"application/json","Content-Length":JSON.stringify(n).length}},i=t.request(r,e=>{var n="";e.on("data",e=>{n+=e}),e.on("end",()=>{n&&n.length>1?a(null,JSON.parse(n)):a("No data available in the response")})}).on("error",e=>{a(e.message)});i.write(JSON.stringify(n)),i.end()}function CamelToSnake(e){return e.replace(/[\w]([A-Z])/g,function(e){return e[0]+"_"+e[1]}).toLowerCase()}function GetMonitoringData(e,n,a){if(e in monitoring_data_cache&&null!=monitoring_data_cache[e]&&JSON.stringify(n.sort())===JSON.stringify(monitoring_data_cache[e].dott_names.sort()))return a(null,monitoring_data_cache[e]);GetLatestNTFi(e,function(t,o){if(t)return a(t);ComposeMonitoringData(o,e,n,function(t,o){if(t)return a(t);monitoring_data_cache[e]=o,monitoring_data_cache[e].dott_names=n,a(null,monitoring_data_cache[e])})})}function ComposeMonitoringData(e,n,a,t){var o={net_data:{},nodes:{},rmacs:{},dobj_info:{}};o.net_data={network_id:e.metadata.net_id,net_guid:n};var r=function(n){var a=e.data_objs[0].networksettings1.find(e=>e.name==n);if(null!=a){if("stack_mon_nms_send_mode"==n){return{0:"Offline",1:"Online",2:"Anycast",3:"Hybrid"}[a.dobj.val]}return a.dobj.val}return null};for(var i in o.net_data.deadband=r("stack_ms_deadband_tmo_s"),o.net_data.send_mode=r("stack_mon_nms_send_mode"),o.net_data.poll_interval=r("stack_mon_remote_min_int_ms"),e.data_objs)if("0"!=i){trace.Debug("ComposeMonitoringData: Processing n_id="+i);var s=null,d=null;for(var l in e.data_objs[i])for(var u in e.data_objs[i][l])"guid"==e.data_objs[i][l][u].name&&(s=e.data_objs[i][l][u].dobj.val),"addr_rmac"==e.data_objs[i][l][u].name&&(d=e.data_objs[i][l][u].dobj.val);if(null!=s&&null!=d){o.nodes[s]={n_id:i},o.rmacs[d]=i,trace.Debug("ComposeMonitoringData: Found data for n_id#"+i+": guid="+s+" rmac="+d),o.nodes[s].dmaps=[];var c=e.nodelist.find(e=>e.node_id==i);for(var _ in c.elements)if(c.elements[_].etname){var f=db_cache.GetElementTypeByName(c.elements[_].etname);o.nodes[s].dmaps.push(f.dmap_id)}}else null==s&&trace.Warning("ComposeMonitoringData: Crucial data is not found! guid="+s+" rmac="+d)}GetMonitoringDobjsInfo(a,o.nodes,function(e,n){if(e)return t(e);o.dobj_info=n,t(null,o)})}function GetNetworkTopology(e,n){GetLatestNTFi(e,function(e,a){if(e)return n(e);a.nodelist.forEach(function(e){var n=e.node_id,t=a.data_objs[n].metainfo_1.find(e=>"ui_name"==e.name),o=a.data_objs[n].metainfo_1.find(e=>"monitoring"==e.name),r=null;for(var i in a.data_objs[n])for(var s in a.data_objs[n][i])"addr_rmac"==a.data_objs[n][i][s].name&&(r=a.data_objs[n][i][s].dobj.val);t&&(e.node_ui_name=t.dobj.val),o&&(e.node_mon=o.dobj.val),r&&(e.node_addr={prefix:"RMAC: ",val:r})});var t={metadata:a.metadata,nodelist:a.nodelist,links:a.links};return n(null,t)})}function GetLatestNTFi(e,n){logdbo.ReadNetMonSyncLog(e,1,function(e,a){if(e||null==a)return n("Failed to get latest NTFi. Error="+e);var t;try{t=JSON.parse(a.data)}catch(e){return n("Can't parse latest NTFi: Invalid JSON format "+e)}return n(null,t)})}function GetMonitoringDobjsInfo(e,n,a){var t={};trace.Debug("GetMonitoringDobjsInfo dott_names="+JSON.stringify(e)),trace.Debug("GetMonitoringDobjsInfo nodes_info="+JSON.stringify(n)),async.eachOfSeries(n,function(n,a,o){crud.FindByTags("dataobjecttypetrees",{name:{$in:e},dmap_id:{$in:n.dmaps}},function(n,a){if(n)return o(n);e.forEach(e=>{t[e]={name:e,postfix:"",prefix:""};var n=a.find(n=>n.name==e);n&&(t[e].postfix=n.units),"link_rssi"!=e&&"last_rssi"!=e||(t[e].prefix="RSSI:"),"link_snr"==e&&(t[e].prefix="SNR:"),"noise_level"==e&&(t[e].prefix="Noise:")}),o()})},function(e){e&&trace.Error("GetMonitoringDobjsInfo: "+e),a(e,t)})}module.exports=function(e,n){return trace=n,flexsettings=e,logdbo=require("../app-lib/ds_client_api/logdbo.js")(e,n),crud=require("../app-lib/ds_client_api/db_crud.js")(e,n),db_cache=require("./ss_data_cache")(e,n),mon_api};